//+------------------------------------------------------------------+
//|                                                      HighLow.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_width1 2
#property indicator_width2 2

extern color warnaup=clrRed;
extern color warnadn=clrBlue;
extern int jarakgenap=7;
extern int jarakganjil=1;
extern int jumlahcandle=200;
extern int setwidth=2;
extern int pnl=500;
extern int txt=490;
extern bool isalarm=true;
extern int menitalarm=1;
extern string sound="suara.wav";

double hHigh[],lLow[];
int aw=0,ak=1;
int cwip,hit=0;
bool alarmon=false;
datetime menit,hitmenit;
string k;
int BH=500,BL=500;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   EventSetTimer(1);
   BH=iHighest(NULL,0,MODE_HIGH,jumlahcandle,0);
   BL=iLowest(NULL,0,MODE_LOW,jumlahcandle,0);
   cwip=ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0);
   menit=iTime(NULL,1,0);
   hitmenit=iTime(NULL,1,1);   
   SetIndexStyle(0,DRAW_ARROW,EMPTY,setwidth,warnaup); //Down
   SetIndexStyle(1,DRAW_ARROW,EMPTY,setwidth,warnadn); //Up
   SetIndexBuffer(0,hHigh);   
   SetIndexBuffer(1,lLow);  
   SetIndexArrow(0,108);    
   SetIndexArrow(1,108);    
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
    ak=rates_total;
    if (isalarm)
     {
       if (iHigh(NULL,0,0)>iHigh(NULL,0,BH))
        {
          alarmon=true;
          k="Break High !!";
          hHigh[BH]=0;
          BH=iHighest(NULL,0,MODE_HIGH,jumlahcandle,0);
        }  
        
       if (iLow(NULL,0,0)<iLow(NULL,0,BL))
        {
          alarmon=true;
          k="Break Low !!!";
          lLow[BL]=EMPTY_VALUE;
          BL=iLowest(NULL,0,MODE_LOW,jumlahcandle,0);
        }          
     }

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   menit=iTime(NULL,1,0);
   if (alarmon)
    {
      alarm(k);
       PlaySound("\\Files\\"+sound);
      if(menit!=hitmenit) {hit++;hitmenit=menit;}
      if(hit>menitalarm) 
      {
        alarmon=false;
        ObjectDelete(0,"FiboExpert1");
        ObjectDelete(0,"FiboExpert11");        
        hit=0;
        PlaySound("");
      } 
    }
   if(aw!=ak)
   { 
    ObjectDelete(0,"FiboExpert1");
    ObjectDelete(0,"FiboExpert11");     
    double higher=0.0,lower=0.0;
    int ihigher=0,ilower=0,pos=0,pos1=0,x=0,y=0;
    ArrayResize(hHigh,jumlahcandle,10); 
    ArrayResize(lLow,jumlahcandle,10); 
    ArrayInitialize(hHigh,0);
    ArrayInitialize(lLow,EMPTY_VALUE);
    int i;
    ObjectsDeleteAll(0,"LBL",0,OBJ_ARROW);
    for (i=jumlahcandle;i>=0;i--)
     {
     
              if (x==0){pos=jarakganjil;}
              else {pos=jarakgenap;} 
                       
              if (y==0) {pos1=jarakganjil;}         
              else {pos1=jarakgenap;}     
             
       if (((iHigh(NULL,0,i)>=iHigh(NULL,0,i-1)))&&((iHigh(NULL,0,i)>=iHigh(NULL,0,i+1))))
        {
          hHigh[i]=iHigh(NULL,0,i)+0.0002;
          ihigher=iHighest(NULL,0,MODE_HIGH,i,0);
          higher=iHigh(NULL,0,ihigher);          
             if (hHigh[i]-0.0002<=higher)
              {
                hHigh[i]=0;
              }        

          if(hHigh[i]!=0)
           {
              BH=i;
      		  ObjectCreate(0,"LBLH"+IntegerToString(i), OBJ_ARROW_RIGHT_PRICE, 0, Time[0]+(Period()*60*(pos)), hHigh[i]);
      		  ObjectSet("LBLH"+IntegerToString(i), OBJPROP_TIME1, Time[0]+(Period()*60*(pos)));
      		  ObjectSet("LBLH"+IntegerToString(i), OBJPROP_PRICE1, hHigh[i]-0.0002);
      		  ObjectSet("LBLH"+IntegerToString(i), OBJPROP_COLOR, warnaup);           
        		  if (x==0) {x++;}
      		  else {x--;}                		             
           }                             
        }

       if (((iLow(NULL,0,i)<=iLow(NULL,0,i-1)))&&((iLow(NULL,0,i)<=iLow(NULL,0,i+1))))
        {
          lLow[i]=iLow(NULL,0,i)-0.0002;
          ilower=iLowest(NULL,0,MODE_LOW,i,0);
          lower=iLow(NULL,0,ilower);
             if (lLow[i]+0.0002>=lower)
              {
                lLow[i]=EMPTY_VALUE;
              }
              
          if(lLow[i]!=EMPTY_VALUE)
           {
              BL=i;
      		  ObjectCreate(0,"LBLL"+IntegerToString(i), OBJ_ARROW_RIGHT_PRICE, 0, Time[0]+(Period()*60*(pos1)), lLow[i]);
      		  ObjectSet("LBLL"+IntegerToString(i), OBJPROP_TIME1, Time[0]+(Period()*60*(pos1)));
      		  ObjectSet("LBLL"+IntegerToString(i), OBJPROP_PRICE1, lLow[i]+0.0002);
      		  ObjectSet("LBLL"+IntegerToString(i), OBJPROP_COLOR, warnadn); 
      		  if (y==0) {y++;}
      		  else {y--;}          
           }                                                
        }        
     }
     aw=ak;
    }
  }
//+------------------------------------------------------------------+

void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
      if (id==CHARTEVENT_OBJECT_CLICK)
     {

        if ((sparam=="FiboExpert1") ||(sparam=="FiboExpert11"))       
        {
           alarmon=false;
           ObjectDelete(0,"FiboExpert1");
           ObjectDelete(0,"FiboExpert11");        
           hit=0;
           PlaySound("");        
        }

     }  
   
  }

void SetText(string name,string text,int x,int y,color colour,int fontsize=12, string font="Arial")
  {
   if(ObjectCreate(0,name,OBJ_LABEL,0,0,0))
     {
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
      ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
      ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
      ObjectSetString(0,name,OBJPROP_FONT,font);
      ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
     }
   ObjectSetString(0,name,OBJPROP_TEXT,text);
  }
  
void SetPanel(string name,int sub_window,int x,int y,int width,int height,color bg_color,color border_clr,int border_width)
  {
   if(ObjectCreate(0,name,OBJ_RECTANGLE_LABEL,sub_window,0,0))
     {
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height);
      ObjectSetInteger(0,name,OBJPROP_COLOR,border_clr);
      ObjectSetInteger(0,name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,border_width);
      ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,name,OBJPROP_BACK,false);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,name,OBJPROP_SELECTED,0);
      ObjectSetInteger(0,name,OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,name,OBJPROP_ZORDER,0);
     }
   ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bg_color);
  }  
  void alarm(string s)
  {
    SetPanel("FiboExpert1",0,cwip-pnl,200,124,50,clrLime,clrBlack,1);
    SetText("FiboExpert11",s,cwip-txt,215,clrBlack,12,"Georgia");
  }